#!/usr/bin/perl -w
#########################################################################
#
# Serz Minus (Sergey Lepenkov), <abalama@cpan.org>
#
# Copyright (C) 1998-2023 D&D Corporation. All Rights Reserved
#
# This is free software; you can redistribute it and/or modify it
# under the same terms as Perl itself.
#
#########################################################################
use Test::More tests => 2;
use NoRFC::Util qw/hash2attr attr2hash/;

# hash2attr
ok(length(hash2attr(foo => 'test', bar => 123, baz => undef)), "Hash to Attributes");

# attr2hash
my %h = attr2hash("baz=; bar=123; foo=test");
is($h{bar}, '123', "Attributes to hash") or diag explain(\%h);

1;

__END__

prove -lv t/07-attr.t
